<?php

namespace Drupal\search_api_vragen_ai;

use Drupal\search_api_vragen_ai\Client\DocumentItem;
use Swis\JsonApi\Client\DocumentClient;
use Swis\JsonApi\Client\Interfaces\ClientInterface;
use Swis\JsonApi\Client\Interfaces\ResponseParserInterface;
use Swis\JsonApi\Client\Interfaces\TypeMapperInterface;
use Swis\JsonApi\Client\TypeMapper;

/**
 * Client to interact with the Vragen.ai API.
 */
class Client extends DocumentClient {

  /**
   * The client.
   */
  private ClientInterface $client;

  /**
   * Constructor.
   *
   * @param \Swis\JsonApi\Client\Interfaces\ClientInterface $client
   *   The client.
   * @param \Swis\JsonApi\Client\Interfaces\ResponseParserInterface $parser
   *   The response parser.
   */
  public function __construct(ClientInterface $client, ResponseParserInterface $parser) {
    parent::__construct($client, $parser);
    $this->client = $client;
  }

  /**
   * Get the client.
   *
   * @return \Swis\JsonApi\Client\Interfaces\ClientInterface
   *   The client.
   */
  public function getClient(): ClientInterface {
    return $this->client;
  }

  /**
   * Get the type mapper.
   *
   * @return \Swis\JsonApi\Client\Interfaces\TypeMapperInterface
   *   The type mapper.
   */
  public static function getTypeMapper(): TypeMapperInterface {
    $typeMapper = new TypeMapper();
    $typeMapper->setMapping('documents', DocumentItem::class);

    return $typeMapper;
  }

}
